<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ThreadSafeEvent.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.event</a> &gt; <span class="el_source">ThreadSafeEvent.java</span></div><h1>ThreadSafeEvent.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.event;

import io.gitlab.littlesaints.protean.configuration.Config;
import io.gitlab.littlesaints.protean.configuration.Props;

import java.util.concurrent.atomic.AtomicLong;
import java.util.concurrent.atomic.AtomicReference;
import java.util.function.Supplier;

/**
 * A {@link java.util.concurrent.ConcurrentHashMap} based implementation of an Event.
 */
public class ThreadSafeEvent implements SimpleEvent {

	private final Props props;

	private final Config confProps;

	private final AtomicReference&lt;State&gt; state;

	private final AtomicLong identifier;

	private final AtomicLong startEpochMillis;

	private final AtomicReference&lt;Object&gt; payload;

<span class="nc" id="L47">	public ThreadSafeEvent(Config config) {</span>
<span class="nc" id="L48">		props = new Props();</span>
<span class="nc" id="L49">		confProps = new Config(config);</span>
<span class="nc" id="L50">		state = new AtomicReference&lt;&gt;(State.SUCCESS);</span>
<span class="nc" id="L51">		identifier = new AtomicLong();</span>
<span class="nc" id="L52">		startEpochMillis = new AtomicLong();</span>
<span class="nc" id="L53">		payload = new AtomicReference&lt;&gt;();</span>
<span class="nc" id="L54">	}</span>

	public void init(Supplier&lt;Long&gt; idGenerator) {
<span class="nc" id="L57">		props.clear();</span>
<span class="nc" id="L58">		state.set(State.SUCCESS);</span>
<span class="nc" id="L59">		identifier.set(idGenerator.get());</span>
<span class="nc" id="L60">		startEpochMillis.set(System.currentTimeMillis());</span>
<span class="nc" id="L61">		payload.set(null);</span>
<span class="nc" id="L62">	}</span>

	public long getIdentifier() {
<span class="nc" id="L65">		return identifier.get();</span>
	}

	@SuppressWarnings(&quot;unchecked&quot;)
	public &lt;T&gt; T getProp(String key) {
<span class="nc" id="L70">		return (T) props.get(key);</span>
	}

	@SuppressWarnings(&quot;unchecked&quot;)
	public &lt;T&gt; T setProp(String key, T value) {
<span class="nc" id="L75">		return (T) props.put(key, value);</span>
	}

	public boolean containsProp(String key) {
<span class="nc" id="L79">		return props.containsKey(key);</span>
	}

	@SuppressWarnings(&quot;unchecked&quot;)
	public &lt;T&gt; T getConfig(String key) {
<span class="nc" id="L84">		return (T) confProps.get(key);</span>
	}

	public State getState() {
<span class="nc" id="L88">		return state.get();</span>
	}

	public void setState(State state) {
<span class="nc" id="L92">		this.state.set(state);</span>
<span class="nc" id="L93">	}</span>

	public long getStartEpochMillis() {
<span class="nc" id="L96">		return startEpochMillis.get();</span>
	}

	public &lt;T&gt; T getPayload() {
<span class="nc" id="L100">		return (T) payload.get();</span>
	}

	public &lt;T&gt; void setPayload(T payload) {
<span class="nc" id="L104">		this.payload.set(payload);</span>
<span class="nc" id="L105">	}</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>